xref: /linux/scripts/Kbuild.include (revision 132db93572821ec2fdf81e354cc40f558faf7e4f)
1# SPDX-License-Identifier: GPL-2.0
2####
3# kbuild: Generic definitions
4
5# Convenient variables
6comma   := ,
7quote   := "
8squote  := '
9empty   :=
10space   := $(empty) $(empty)
11space_escape := _-_SPACE_-_
12pound := \#
13
14###
15# Name of target with a '.' as filename prefix. foo/bar.o => foo/.bar.o
16dot-target = $(dir $@).$(notdir $@)
17
18###
19# The temporary file to save gcc -MMD generated dependencies must not
20# contain a comma
21depfile = $(subst $(comma),_,$(dot-target).d)
22
23###
24# filename of target with directory and extension stripped
25basetarget = $(basename $(notdir $@))
26
27###
28# real prerequisites without phony targets
29real-prereqs = $(filter-out $(PHONY), $^)
30
31###
32# Escape single quote for use in echo statements
33escsq = $(subst $(squote),'\$(squote)',$1)
34
35###
36# Quote a string to pass it to C files. foo => '"foo"'
37stringify = $(squote)$(quote)$1$(quote)$(squote)
38
39###
40# Easy method for doing a status message
41       kecho := :
42 quiet_kecho := echo
43silent_kecho := :
44kecho := $($(quiet)kecho)
45
46###
47# filechk is used to check if the content of a generated file is updated.
48# Sample usage:
49#
50# filechk_sample = echo $(KERNELRELEASE)
51# version.h: FORCE
52#	$(call filechk,sample)
53#
54# The rule defined shall write to stdout the content of the new file.
55# The existing file will be compared with the new one.
56# - If no file exist it is created
57# - If the content differ the new file is used
58# - If they are equal no change, and no timestamp update
59# - stdin is piped in from the first prerequisite ($<) so one has
60#   to specify a valid file as first prerequisite (often the kbuild file)
61define filechk
62	$(Q)set -e;						\
63	mkdir -p $(dir $@);					\
64	trap "rm -f $(dot-target).tmp" EXIT;			\
65	{ $(filechk_$(1)); } > $(dot-target).tmp;		\
66	if [ ! -r $@ ] || ! cmp -s $@ $(dot-target).tmp; then	\
67		$(kecho) '  UPD     $@';			\
68		mv -f $(dot-target).tmp $@;			\
69	fi
70endef
71
72######
73# gcc support functions
74# See documentation in Documentation/kbuild/makefiles.rst
75
76# cc-cross-prefix
77# Usage: CROSS_COMPILE := $(call cc-cross-prefix, m68k-linux-gnu- m68k-linux-)
78# Return first <prefix> where a <prefix>gcc is found in PATH.
79# If no gcc found in PATH with listed prefixes return nothing
80#
81# Note: '2>/dev/null' is here to force Make to invoke a shell. Otherwise, it
82# would try to directly execute the shell builtin 'command'. This workaround
83# should be kept for a long time since this issue was fixed only after the
84# GNU Make 4.2.1 release.
85cc-cross-prefix = $(firstword $(foreach c, $(1), \
86			$(if $(shell command -v -- $(c)gcc 2>/dev/null), $(c))))
87
88# output directory for tests below
89TMPOUT = $(if $(KBUILD_EXTMOD),$(firstword $(KBUILD_EXTMOD))/).tmp_$$$$
90
91# try-run
92# Usage: option = $(call try-run, $(CC)...-o "$$TMP",option-ok,otherwise)
93# Exit code chooses option. "$$TMP" serves as a temporary file and is
94# automatically cleaned up.
95try-run = $(shell set -e;		\
96	TMP=$(TMPOUT)/tmp;		\
97	TMPO=$(TMPOUT)/tmp.o;		\
98	mkdir -p $(TMPOUT);		\
99	trap "rm -rf $(TMPOUT)" EXIT;	\
100	if ($(1)) >/dev/null 2>&1;	\
101	then echo "$(2)";		\
102	else echo "$(3)";		\
103	fi)
104
105# as-option
106# Usage: cflags-y += $(call as-option,-Wa$(comma)-isa=foo,)
107
108as-option = $(call try-run,\
109	$(CC) $(KBUILD_CFLAGS) $(1) -c -x assembler /dev/null -o "$$TMP",$(1),$(2))
110
111# as-instr
112# Usage: cflags-y += $(call as-instr,instr,option1,option2)
113
114as-instr = $(call try-run,\
115	printf "%b\n" "$(1)" | $(CC) $(KBUILD_AFLAGS) -c -x assembler -o "$$TMP" -,$(2),$(3))
116
117# __cc-option
118# Usage: MY_CFLAGS += $(call __cc-option,$(CC),$(MY_CFLAGS),-march=winchip-c6,-march=i586)
119__cc-option = $(call try-run,\
120	$(1) -Werror $(2) $(3) -c -x c /dev/null -o "$$TMP",$(3),$(4))
121
122# Do not attempt to build with gcc plugins during cc-option tests.
123# (And this uses delayed resolution so the flags will be up to date.)
124CC_OPTION_CFLAGS = $(filter-out $(GCC_PLUGINS_CFLAGS),$(KBUILD_CFLAGS))
125
126# cc-option
127# Usage: cflags-y += $(call cc-option,-march=winchip-c6,-march=i586)
128
129cc-option = $(call __cc-option, $(CC),\
130	$(KBUILD_CPPFLAGS) $(CC_OPTION_CFLAGS),$(1),$(2))
131
132# cc-option-yn
133# Usage: flag := $(call cc-option-yn,-march=winchip-c6)
134cc-option-yn = $(call try-run,\
135	$(CC) -Werror $(KBUILD_CPPFLAGS) $(CC_OPTION_CFLAGS) $(1) -c -x c /dev/null -o "$$TMP",y,n)
136
137# cc-disable-warning
138# Usage: cflags-y += $(call cc-disable-warning,unused-but-set-variable)
139cc-disable-warning = $(call try-run,\
140	$(CC) -Werror $(KBUILD_CPPFLAGS) $(CC_OPTION_CFLAGS) -W$(strip $(1)) -c -x c /dev/null -o "$$TMP",-Wno-$(strip $(1)))
141
142# cc-ifversion
143# Usage:  EXTRA_CFLAGS += $(call cc-ifversion, -lt, 0402, -O1)
144cc-ifversion = $(shell [ $(CONFIG_GCC_VERSION)0 $(1) $(2)000 ] && echo $(3) || echo $(4))
145
146# ld-option
147# Usage: KBUILD_LDFLAGS += $(call ld-option, -X, -Y)
148ld-option = $(call try-run, $(LD) $(KBUILD_LDFLAGS) $(1) -v,$(1),$(2),$(3))
149
150# ld-version
151# Note this is mainly for HJ Lu's 3 number binutil versions
152ld-version = $(shell $(LD) --version | $(srctree)/scripts/ld-version.sh)
153
154# ld-ifversion
155# Usage:  $(call ld-ifversion, -ge, 22252, y)
156ld-ifversion = $(shell [ $(ld-version) $(1) $(2) ] && echo $(3) || echo $(4))
157
158######
159
160###
161# Shorthand for $(Q)$(MAKE) -f scripts/Makefile.build obj=
162# Usage:
163# $(Q)$(MAKE) $(build)=dir
164build := -f $(srctree)/scripts/Makefile.build obj
165
166###
167# Shorthand for $(Q)$(MAKE) -f scripts/Makefile.dtbinst obj=
168# Usage:
169# $(Q)$(MAKE) $(dtbinst)=dir
170dtbinst := -f $(srctree)/scripts/Makefile.dtbinst obj
171
172###
173# Shorthand for $(Q)$(MAKE) -f scripts/Makefile.clean obj=
174# Usage:
175# $(Q)$(MAKE) $(clean)=dir
176clean := -f $(srctree)/scripts/Makefile.clean obj
177
178# echo command.
179# Short version is used, if $(quiet) equals `quiet_', otherwise full one.
180echo-cmd = $(if $($(quiet)cmd_$(1)),\
181	echo '  $(call escsq,$($(quiet)cmd_$(1)))$(echo-why)';)
182
183# printing commands
184cmd = @set -e; $(echo-cmd) $(cmd_$(1))
185
186###
187# if_changed      - execute command if any prerequisite is newer than
188#                   target, or command line has changed
189# if_changed_dep  - as if_changed, but uses fixdep to reveal dependencies
190#                   including used config symbols
191# if_changed_rule - as if_changed but execute rule instead
192# See Documentation/kbuild/makefiles.rst for more info
193
194ifneq ($(KBUILD_NOCMDDEP),1)
195# Check if both commands are the same including their order. Result is empty
196# string if equal. User may override this check using make KBUILD_NOCMDDEP=1
197cmd-check = $(filter-out $(subst $(space),$(space_escape),$(strip $(cmd_$@))), \
198                         $(subst $(space),$(space_escape),$(strip $(cmd_$1))))
199else
200cmd-check = $(if $(strip $(cmd_$@)),,1)
201endif
202
203# Replace >$< with >$$< to preserve $ when reloading the .cmd file
204# (needed for make)
205# Replace >#< with >$(pound)< to avoid starting a comment in the .cmd file
206# (needed for make)
207# Replace >'< with >'\''< to be able to enclose the whole string in '...'
208# (needed for the shell)
209make-cmd = $(call escsq,$(subst $(pound),$$(pound),$(subst $$,$$$$,$(cmd_$(1)))))
210
211# Find any prerequisites that are newer than target or that do not exist.
212# (This is not true for now; $? should contain any non-existent prerequisites,
213# but it does not work as expected when .SECONDARY is present. This seems a bug
214# of GNU Make.)
215# PHONY targets skipped in both cases.
216newer-prereqs = $(filter-out $(PHONY),$?)
217
218# Execute command if command has changed or prerequisite(s) are updated.
219if_changed = $(if $(newer-prereqs)$(cmd-check),                              \
220	$(cmd);                                                              \
221	printf '%s\n' 'cmd_$@ := $(make-cmd)' > $(dot-target).cmd, @:)
222
223# Execute the command and also postprocess generated .d dependencies file.
224if_changed_dep = $(if $(newer-prereqs)$(cmd-check),$(cmd_and_fixdep),@:)
225
226cmd_and_fixdep =                                                             \
227	$(cmd);                                                              \
228	scripts/basic/fixdep $(depfile) $@ '$(make-cmd)' > $(dot-target).cmd;\
229	rm -f $(depfile)
230
231# Usage: $(call if_changed_rule,foo)
232# Will check if $(cmd_foo) or any of the prerequisites changed,
233# and if so will execute $(rule_foo).
234if_changed_rule = $(if $(newer-prereqs)$(cmd-check),$(rule_$(1)),@:)
235
236###
237# why - tell why a target got built
238#       enabled by make V=2
239#       Output (listed in the order they are checked):
240#          (1) - due to target is PHONY
241#          (2) - due to target missing
242#          (3) - due to: file1.h file2.h
243#          (4) - due to command line change
244#          (5) - due to missing .cmd file
245#          (6) - due to target not in $(targets)
246# (1) PHONY targets are always build
247# (2) No target, so we better build it
248# (3) Prerequisite is newer than target
249# (4) The command line stored in the file named dir/.target.cmd
250#     differed from actual command line. This happens when compiler
251#     options changes
252# (5) No dir/.target.cmd file (used to store command line)
253# (6) No dir/.target.cmd file and target not listed in $(targets)
254#     This is a good hint that there is a bug in the kbuild file
255ifeq ($(KBUILD_VERBOSE),2)
256why =                                                                        \
257    $(if $(filter $@, $(PHONY)),- due to target is PHONY,                    \
258        $(if $(wildcard $@),                                                 \
259            $(if $(newer-prereqs),- due to: $(newer-prereqs),                \
260                $(if $(cmd-check),                                           \
261                    $(if $(cmd_$@),- due to command line change,             \
262                        $(if $(filter $@, $(targets)),                       \
263                            - due to missing .cmd file,                      \
264                            - due to $(notdir $@) not in $$(targets)         \
265                         )                                                   \
266                     )                                                       \
267                 )                                                           \
268             ),                                                              \
269             - due to target missing                                         \
270         )                                                                   \
271     )
272
273echo-why = $(call escsq, $(strip $(why)))
274endif
275
276###############################################################################
277#
278# When a Kconfig string contains a filename, it is suitable for
279# passing to shell commands. It is surrounded by double-quotes, and
280# any double-quotes or backslashes within it are escaped by
281# backslashes.
282#
283# This is no use for dependencies or $(wildcard). We need to strip the
284# surrounding quotes and the escaping from quotes and backslashes, and
285# we *do* need to escape any spaces in the string. So, for example:
286#
287# Usage: $(eval $(call config_filename,FOO))
288#
289# Defines FOO_FILENAME based on the contents of the CONFIG_FOO option,
290# transformed as described above to be suitable for use within the
291# makefile.
292#
293# Also, if the filename is a relative filename and exists in the source
294# tree but not the build tree, define FOO_SRCPREFIX as $(srctree)/ to
295# be prefixed to *both* command invocation and dependencies.
296#
297# Note: We also print the filenames in the quiet_cmd_foo text, and
298# perhaps ought to have a version specially escaped for that purpose.
299# But it's only cosmetic, and $(patsubst "%",%,$(CONFIG_FOO)) is good
300# enough.  It'll strip the quotes in the common case where there's no
301# space and it's a simple filename, and it'll retain the quotes when
302# there's a space. There are some esoteric cases in which it'll print
303# the wrong thing, but we don't really care. The actual dependencies
304# and commands *do* get it right, with various combinations of single
305# and double quotes, backslashes and spaces in the filenames.
306#
307###############################################################################
308#
309define config_filename
310ifneq ($$(CONFIG_$(1)),"")
311$(1)_FILENAME := $$(subst \\,\,$$(subst \$$(quote),$$(quote),$$(subst $$(space_escape),\$$(space),$$(patsubst "%",%,$$(subst $$(space),$$(space_escape),$$(CONFIG_$(1)))))))
312ifneq ($$(patsubst /%,%,$$(firstword $$($(1)_FILENAME))),$$(firstword $$($(1)_FILENAME)))
313else
314ifeq ($$(wildcard $$($(1)_FILENAME)),)
315ifneq ($$(wildcard $$(srctree)/$$($(1)_FILENAME)),)
316$(1)_SRCPREFIX := $(srctree)/
317endif
318endif
319endif
320endif
321endef
322#
323###############################################################################
324
325# delete partially updated (i.e. corrupted) files on error
326.DELETE_ON_ERROR:
327
328# do not delete intermediate files automatically
329.SECONDARY:
330